#||#||#||#||#||#||#||#||#||#||#
#  Mineral Portals - 1.20.1   #
#  Tijd4Jan                   #
#||#||#||#||#||#||#||#||#||#||#

## Detect portals (Survival, Adventure)
execute as @a[scores={tpCooldown=40..},gamemode=!creative,gamemode=!spectator,nbt={Inventory:[{id:"minecraft:lapis_block"}]}] at @s if block ~ ~-2 ~ minecraft:copper_ore if block ~ ~-3 ~ minecraft:waxed_copper_block if block ~ ~-4 ~ minecraft:deepslate_copper_ore run function mineral_portals:copper/copper_portals
execute as @a[scores={tpCooldown=40..},gamemode=!creative,gamemode=!spectator,nbt={Inventory:[{id:"minecraft:lapis_block"}]}] at @s if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:lapis_block",Count:1b}}] run function mineral_portals:emerald/emerald_portals
execute as @a[scores={tpCooldown=40..},gamemode=!creative,gamemode=!spectator,nbt={Inventory:[{id:"minecraft:lapis_block"}]}] at @s if block ~ ~-2 ~ minecraft:emerald_ore if block ~ ~-3 ~ minecraft:emerald_block if block ~ ~-4 ~ minecraft:deepslate_emerald_ore run function mineral_portals:emerald/emerald_portals
execute as @a[scores={tpCooldown=40..},gamemode=!creative,gamemode=!spectator,nbt={Inventory:[{id:"minecraft:lapis_block"}]}] at @s if block ~ ~-2 ~ minecraft:diamond_ore if block ~ ~-3 ~ minecraft:diamond_block if block ~ ~-4 ~ minecraft:deepslate_diamond_ore run function mineral_portals:diamond/diamond_portals

## Detect portals (Creative, Spectator)
execute as @a[scores={tpCooldown=40..},gamemode=!survival,gamemode=!adventure] at @s if block ~ ~-2 ~ minecraft:copper_ore if block ~ ~-3 ~ minecraft:waxed_copper_block if block ~ ~-4 ~ minecraft:deepslate_copper_ore run function mineral_portals:copper/copper_portals
execute as @a[scores={tpCooldown=40..},gamemode=!survival,gamemode=!adventure] at @s if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:lapis_block",Count:1b}}] run function mineral_portals:emerald/emerald_portals
execute as @a[scores={tpCooldown=40..},gamemode=!survival,gamemode=!adventure] at @s if block ~ ~-2 ~ minecraft:emerald_ore if block ~ ~-3 ~ minecraft:emerald_block if block ~ ~-4 ~ minecraft:deepslate_emerald_ore run function mineral_portals:emerald/emerald_portals
execute as @a[scores={tpCooldown=40..},gamemode=!survival,gamemode=!adventure] at @s if block ~ ~-2 ~ minecraft:diamond_ore if block ~ ~-3 ~ minecraft:diamond_block if block ~ ~-4 ~ minecraft:deepslate_diamond_ore run function mineral_portals:diamond/diamond_portals

## Remove portals
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-1 ~ #mineral_portals:glass-types run forceload remove ~ ~
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-2 ~ minecraft:copper_ore run forceload remove ~ ~
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-3 ~ minecraft:waxed_copper_block run forceload remove ~ ~
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-4 ~ minecraft:deepslate_copper_ore run forceload remove ~ ~

execute as @e[type=marker,tag=cp] at @s unless block ~ ~-1 ~ #mineral_portals:glass-types run kill @s
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-2 ~ minecraft:copper_ore run kill @s
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-3 ~ minecraft:waxed_copper_block run kill @s
execute as @e[type=marker,tag=cp] at @s unless block ~ ~-4 ~ minecraft:deepslate_copper_ore run kill @s

execute as @e[type=marker,tag=ep] at @s unless block ~ ~-1 ~ #mineral_portals:glass-types run forceload remove ~ ~
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-2 ~ minecraft:emerald_ore run forceload remove ~ ~
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-3 ~ minecraft:emerald_block run forceload remove ~ ~
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-4 ~ minecraft:deepslate_emerald_ore run forceload remove ~ ~

execute as @e[type=marker,tag=ep] at @s unless block ~ ~-1 ~ #mineral_portals:glass-types run kill @s
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-2 ~ minecraft:emerald_ore run kill @s
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-3 ~ minecraft:emerald_block run kill @s
execute as @e[type=marker,tag=ep] at @s unless block ~ ~-4 ~ minecraft:deepslate_emerald_ore run kill @s

execute as @e[type=marker,tag=dp] at @s unless block ~ ~-1 ~ minecraft:glass unless block ~ ~-1 ~ minecraft:tinted_glass unless block ~ ~-1 ~ #mineral_portals:glass-types run forceload remove ~ ~
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-2 ~ minecraft:diamond_ore run forceload remove ~ ~
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-3 ~ minecraft:diamond_block run forceload remove ~ ~
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-4 ~ minecraft:deepslate_diamond_ore run forceload remove ~ ~

execute as @e[type=marker,tag=dp] at @s unless block ~ ~-1 ~ minecraft:glass unless block ~ ~-1 ~ minecraft:tinted_glass unless block ~ ~-1 ~ #mineral_portals:glass-types run kill @s
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-2 ~ minecraft:diamond_ore run kill @s
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-3 ~ minecraft:diamond_block run kill @s
execute as @e[type=marker,tag=dp] at @s unless block ~ ~-4 ~ minecraft:deepslate_diamond_ore run kill @s

## Fancy
execute as @e[type=marker,tag=cp] at @s run particle dust 0.831 0.443 0.141 1 ~ ~-0.1 ~ 0.3 0.1 0.3 0.2 2
execute as @e[type=marker,tag=ep] at @s run particle dust 0.153 0.831 0.141 1 ~ ~-0.1 ~ 0.3 0.1 0.3 0.2 2
execute as @e[type=marker,tag=dp] at @s run particle dust 0.247 0.788 0.894 1 ~ ~-0.1 ~ 0.3 0.1 0.3 0.2 2

## Mineral Portals Installed
scoreboard players set @a mineralPortals 1